git-stash.shon commit get_author_ident_from_commit(): remove useless quoting (9facb3b)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
  11   or: $dashless clear"
  12
  13SUBDIRECTORY_OK=Yes
  14OPTIONS_SPEC=
  15. git-sh-setup
  16require_work_tree
  17cd_to_toplevel
  18
  19TMP="$GIT_DIR/.git-stash.$$"
  20trap 'rm -f "$TMP-*"' 0
  21
  22ref_stash=refs/stash
  23
  24if git config --get-colorbool color.interactive; then
  25       help_color="$(git config --get-color color.interactive.help 'red bold')"
  26       reset_color="$(git config --get-color '' reset)"
  27else
  28       help_color=
  29       reset_color=
  30fi
  31
  32no_changes () {
  33        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  34        git diff-files --quiet --ignore-submodules
  35}
  36
  37clear_stash () {
  38        if test $# != 0
  39        then
  40                die "git stash clear with parameters is unimplemented"
  41        fi
  42        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  43        then
  44                git update-ref -d $ref_stash $current
  45        fi
  46}
  47
  48create_stash () {
  49        stash_msg="$1"
  50
  51        git update-index -q --refresh
  52        if no_changes
  53        then
  54                exit 0
  55        fi
  56
  57        # state of the base commit
  58        if b_commit=$(git rev-parse --verify HEAD)
  59        then
  60                head=$(git rev-list --oneline -n 1 HEAD --)
  61        else
  62                die "You do not have the initial commit yet"
  63        fi
  64
  65        if branch=$(git symbolic-ref -q HEAD)
  66        then
  67                branch=${branch#refs/heads/}
  68        else
  69                branch='(no branch)'
  70        fi
  71        msg=$(printf '%s: %s' "$branch" "$head")
  72
  73        # state of the index
  74        i_tree=$(git write-tree) &&
  75        i_commit=$(printf 'index on %s\n' "$msg" |
  76                git commit-tree $i_tree -p $b_commit) ||
  77                die "Cannot save the current index state"
  78
  79        if test -z "$patch_mode"
  80        then
  81
  82                # state of the working tree
  83                w_tree=$( (
  84                        rm -f "$TMP-index" &&
  85                        cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
  86                        GIT_INDEX_FILE="$TMP-index" &&
  87                        export GIT_INDEX_FILE &&
  88                        git read-tree -m $i_tree &&
  89                        git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
  90                        git write-tree &&
  91                        rm -f "$TMP-index"
  92                ) ) ||
  93                        die "Cannot save the current worktree state"
  94
  95        else
  96
  97                rm -f "$TMP-index" &&
  98                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
  99
 100                # find out what the user wants
 101                GIT_INDEX_FILE="$TMP-index" \
 102                        git add--interactive --patch=stash -- &&
 103
 104                # state of the working tree
 105                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 106                die "Cannot save the current worktree state"
 107
 108                git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
 109                test -s "$TMP-patch" ||
 110                die "No changes selected"
 111
 112                rm -f "$TMP-index" ||
 113                die "Cannot remove temporary index (can't happen)"
 114
 115        fi
 116
 117        # create the stash
 118        if test -z "$stash_msg"
 119        then
 120                stash_msg=$(printf 'WIP on %s' "$msg")
 121        else
 122                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 123        fi
 124        w_commit=$(printf '%s\n' "$stash_msg" |
 125                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
 126                die "Cannot record working tree state"
 127}
 128
 129save_stash () {
 130        keep_index=
 131        patch_mode=
 132        while test $# != 0
 133        do
 134                case "$1" in
 135                -k|--keep-index)
 136                        keep_index=t
 137                        ;;
 138                --no-keep-index)
 139                        keep_index=
 140                        ;;
 141                -p|--patch)
 142                        patch_mode=t
 143                        keep_index=t
 144                        ;;
 145                -q|--quiet)
 146                        GIT_QUIET=t
 147                        ;;
 148                --)
 149                        shift
 150                        break
 151                        ;;
 152                -*)
 153                        echo "error: unknown option for 'stash save': $1"
 154                        echo "       To provide a message, use git stash save -- '$1'"
 155                        usage
 156                        ;;
 157                *)
 158                        break
 159                        ;;
 160                esac
 161                shift
 162        done
 163
 164        stash_msg="$*"
 165
 166        git update-index -q --refresh
 167        if no_changes
 168        then
 169                say 'No local changes to save'
 170                exit 0
 171        fi
 172        test -f "$GIT_DIR/logs/$ref_stash" ||
 173                clear_stash || die "Cannot initialize stash"
 174
 175        create_stash "$stash_msg"
 176
 177        # Make sure the reflog for stash is kept.
 178        : >>"$GIT_DIR/logs/$ref_stash"
 179
 180        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
 181                die "Cannot save the current status"
 182        say Saved working directory and index state "$stash_msg"
 183
 184        if test -z "$patch_mode"
 185        then
 186                git reset --hard ${GIT_QUIET:+-q}
 187
 188                if test -n "$keep_index" && test -n $i_tree
 189                then
 190                        git read-tree --reset -u $i_tree
 191                fi
 192        else
 193                git apply -R < "$TMP-patch" ||
 194                die "Cannot remove worktree changes"
 195
 196                if test -z "$keep_index"
 197                then
 198                        git reset
 199                fi
 200        fi
 201}
 202
 203have_stash () {
 204        git rev-parse --verify $ref_stash >/dev/null 2>&1
 205}
 206
 207list_stash () {
 208        have_stash || return 0
 209        git log --format="%gd: %gs" -g "$@" $ref_stash --
 210}
 211
 212show_stash () {
 213        assert_stash_like "$@"
 214
 215        git diff ${FLAGS:---stat} $b_commit $w_commit
 216}
 217
 218#
 219# Parses the remaining options looking for flags and
 220# at most one revision defaulting to ${ref_stash}@{0}
 221# if none found.
 222#
 223# Derives related tree and commit objects from the
 224# revision, if one is found.
 225#
 226# stash records the work tree, and is a merge between the
 227# base commit (first parent) and the index tree (second parent).
 228#
 229#   REV is set to the symbolic version of the specified stash-like commit
 230#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
 231#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
 232#   s is set to the SHA1 of the stash commit
 233#   w_commit is set to the commit containing the working tree
 234#   b_commit is set to the base commit
 235#   i_commit is set to the commit containing the index tree
 236#   w_tree is set to the working tree
 237#   b_tree is set to the base tree
 238#   i_tree is set to the index tree
 239#
 240#   GIT_QUIET is set to t if -q is specified
 241#   INDEX_OPTION is set to --index if --index is specified.
 242#   FLAGS is set to the remaining flags
 243#
 244# dies if:
 245#   * too many revisions specified
 246#   * no revision is specified and there is no stash stack
 247#   * a revision is specified which cannot be resolve to a SHA1
 248#   * a non-existent stash reference is specified
 249#
 250
 251parse_flags_and_rev()
 252{
 253        test "$PARSE_CACHE" = "$*" && return 0 # optimisation
 254        PARSE_CACHE="$*"
 255
 256        IS_STASH_LIKE=
 257        IS_STASH_REF=
 258        INDEX_OPTION=
 259        s=
 260        w_commit=
 261        b_commit=
 262        i_commit=
 263        w_tree=
 264        b_tree=
 265        i_tree=
 266
 267        # Work around rev-parse --flags eating -q
 268        for opt
 269        do
 270                case "$opt" in
 271                -q|--quiet)
 272                        GIT_QUIET=t
 273                        ;;
 274                esac
 275        done
 276
 277        REV=$(git rev-parse --no-flags --symbolic "$@" 2>/dev/null)
 278        FLAGS=$(git rev-parse --no-revs --flags "$@" 2>/dev/null)
 279
 280        set -- $FLAGS
 281
 282        FLAGS=
 283        while test $# -ne 0
 284        do
 285                case "$1" in
 286                        --index)
 287                                INDEX_OPTION=--index
 288                        ;;
 289                        --)
 290                                :
 291                        ;;
 292                        *)
 293                                FLAGS="${FLAGS}${FLAGS:+ }$1"
 294                        ;;
 295                esac
 296                shift
 297        done
 298
 299        set -- $REV
 300
 301        case $# in
 302                0)
 303                        have_stash || die "No stash found."
 304                        set -- ${ref_stash}@{0}
 305                ;;
 306                1)
 307                        :
 308                ;;
 309                *)
 310                        die "Too many revisions specified: $REV"
 311                ;;
 312        esac
 313
 314        REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"
 315
 316        i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
 317        set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
 318        s=$1 &&
 319        w_commit=$1 &&
 320        b_commit=$2 &&
 321        w_tree=$3 &&
 322        b_tree=$4 &&
 323        i_tree=$5 &&
 324        IS_STASH_LIKE=t &&
 325        test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
 326        IS_STASH_REF=t
 327
 328        if test "${REV}" != "${REV%{*\}}"
 329        then
 330                # maintainers: it would be better if git rev-parse indicated
 331                # this condition with a non-zero status code but as of 1.7.2.1 it
 332                # it did not. So, we use non-empty stderr output as a proxy for the
 333                # condition of interest.
 334                test -z "$(git rev-parse "$REV" 2>&1 >/dev/null)" || die "$REV does not exist in the stash log"
 335        fi
 336
 337}
 338
 339is_stash_like()
 340{
 341        parse_flags_and_rev "$@"
 342        test -n "$IS_STASH_LIKE"
 343}
 344
 345assert_stash_like() {
 346        is_stash_like "$@" || die "'$*' is not a stash-like commit"
 347}
 348
 349is_stash_ref() {
 350        is_stash_like "$@" && test -n "$IS_STASH_REF"
 351}
 352
 353assert_stash_ref() {
 354        is_stash_ref "$@" || die "'$*' is not a stash reference"
 355}
 356
 357apply_stash () {
 358
 359        assert_stash_like "$@"
 360
 361        git update-index -q --refresh &&
 362        git diff-files --quiet --ignore-submodules ||
 363                die 'Cannot apply to a dirty working tree, please stage your changes'
 364
 365        # current index state
 366        c_tree=$(git write-tree) ||
 367                die 'Cannot apply a stash in the middle of a merge'
 368
 369        unstashed_index_tree=
 370        if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
 371                        test "$c_tree" != "$i_tree"
 372        then
 373                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 374                test $? -ne 0 &&
 375                        die 'Conflicts in index. Try without --index.'
 376                unstashed_index_tree=$(git write-tree) ||
 377                        die 'Could not save index tree'
 378                git reset
 379        fi
 380
 381        eval "
 382                GITHEAD_$w_tree='Stashed changes' &&
 383                GITHEAD_$c_tree='Updated upstream' &&
 384                GITHEAD_$b_tree='Version stash was based on' &&
 385                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 386        "
 387
 388        if test -n "$GIT_QUIET"
 389        then
 390                export GIT_MERGE_VERBOSITY=0
 391        fi
 392        if git merge-recursive $b_tree -- $c_tree $w_tree
 393        then
 394                # No conflict
 395                if test -n "$unstashed_index_tree"
 396                then
 397                        git read-tree "$unstashed_index_tree"
 398                else
 399                        a="$TMP-added" &&
 400                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 401                        git read-tree --reset $c_tree &&
 402                        git update-index --add --stdin <"$a" ||
 403                                die "Cannot unstage modified files"
 404                        rm -f "$a"
 405                fi
 406                squelch=
 407                if test -n "$GIT_QUIET"
 408                then
 409                        squelch='>/dev/null 2>&1'
 410                fi
 411                eval "git status $squelch" || :
 412        else
 413                # Merge conflict; keep the exit status from merge-recursive
 414                status=$?
 415                if test -n "$INDEX_OPTION"
 416                then
 417                        echo >&2 'Index was not unstashed.'
 418                fi
 419                exit $status
 420        fi
 421}
 422
 423pop_stash() {
 424        assert_stash_ref "$@"
 425
 426        apply_stash "$@" &&
 427        drop_stash "$@"
 428}
 429
 430drop_stash () {
 431        assert_stash_ref "$@"
 432
 433        git reflog delete --updateref --rewrite "${REV}" &&
 434                say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
 435
 436        # clear_stash if we just dropped the last stash entry
 437        git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
 438}
 439
 440apply_to_branch () {
 441        test -n "$1" || die 'No branch name specified'
 442        branch=$1
 443        shift 1
 444
 445        set -- --index "$@"
 446        assert_stash_like "$@"
 447
 448        git checkout -b $branch $REV^ &&
 449        apply_stash "$@"
 450
 451        test -z "$IS_STASH_REF" || drop_stash "$@"
 452}
 453
 454PARSE_CACHE='--not-parsed'
 455# The default command is "save" if nothing but options are given
 456seen_non_option=
 457for opt
 458do
 459        case "$opt" in
 460        -*) ;;
 461        *) seen_non_option=t; break ;;
 462        esac
 463done
 464
 465test -n "$seen_non_option" || set "save" "$@"
 466
 467# Main command set
 468case "$1" in
 469list)
 470        shift
 471        list_stash "$@"
 472        ;;
 473show)
 474        shift
 475        show_stash "$@"
 476        ;;
 477save)
 478        shift
 479        save_stash "$@"
 480        ;;
 481apply)
 482        shift
 483        apply_stash "$@"
 484        ;;
 485clear)
 486        shift
 487        clear_stash "$@"
 488        ;;
 489create)
 490        if test $# -gt 0 && test "$1" = create
 491        then
 492                shift
 493        fi
 494        create_stash "$*" && echo "$w_commit"
 495        ;;
 496drop)
 497        shift
 498        drop_stash "$@"
 499        ;;
 500pop)
 501        shift
 502        pop_stash "$@"
 503        ;;
 504branch)
 505        shift
 506        apply_to_branch "$@"
 507        ;;
 508*)
 509        case $# in
 510        0)
 511                save_stash &&
 512                say '(To restore them type "git stash apply")'
 513                ;;
 514        *)
 515                usage
 516        esac
 517        ;;
 518esac